#pragma warning(disable: 4668)

#include "AA_AudioSample.h"
#include "AudioAnalyzerManager.h"
#include "Runtime/Core/Public/Misc/Paths.h"

// Sets default values
AAA_AudioSample::AAA_AudioSample()
{
	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
}

//Bind to delegate
void AAA_AudioSample::OnPlayerInitEnds(bool Result)
{
	if (Result)
	{
		// Type: Linear
		// Channel Mode: All in one
		// Channel: 0
		// Num Freq Bands: 1
		// Time Window: 0.02s
		// History Size: 30
		// Use Peak Values: true
		// Num Peaks: 1
		_AAManager->InitSpectrumConfig(EAA_SpectrumType::ST_Linear, EAA_ChannelSelectionMode::All_in_one, 0, 1, 0.02, 30, true, 1);
		_AAManager->Play();
	}
}

// Called when the game starts or when spawned
void AAA_AudioSample::BeginPlay()
{
	Super::BeginPlay();

	//Construct AudioAnalyzerManager BP and Set
	_AAManager = NewObject<UAudioAnalyzerManager>(this, TEXT("AAManager"));

	//Bind Events
	_AAManager->OnInitPlayerAudioFinished.AddDynamic(this, &AAA_AudioSample::OnPlayerInitEnds);

	//Async Init Player audio and Play
	FString AudioFileName = FPaths::ProjectContentDir() + "NonAssets/sample1.wav";
	_AAManager->AsyncInitPlayerAudio(AudioFileName);
}

// Called every frame
void AAA_AudioSample::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

	if (_AAManager && _AAManager->IsPlaying())
	{
		TArray<float> Frequencies;
		TArray<float> AverageFrequencies;
		_AAManager->GetSpectrum(Frequencies, AverageFrequencies, false);

		if (GEngine)
			GEngine->AddOnScreenDebugMessage(-1, 5.f, FColor::Cyan, FString::Printf(TEXT("%f"), Frequencies[0]));
	}
}
